/*
You are free to use/modify this plug-in while you maintain the "Nican132.com" for public in view
Like in function "Propaganda"

Author: Nican132
*/

#include <sourcemod>
#include <sdktools>
#define PLUGIN_VERSION "1.0"

#define TIMETILLNEXT 150
#define ZMMAXPLAYERS 16

new maxents, maxplayers

#define MAXTRIGGERS 4
static String:triggers[MAXTRIGGERS][] = { "rtd","rollthedice","diceroll","rolldice"}

//People can only use ROLL once a death
new HasAlredyUsed[ZMMAXPLAYERS + 1];
new CurrentlyUsing[ZMMAXPLAYERS + 1];
new TimeLeft[ZMMAXPLAYERS + 1];

new Handle:LoopTimer = INVALID_HANDLE;

static String:GiveWeapon[3][] = { "weapon_zm_shotgun" , "weapon_zm_rifle" , "weapon_zm_mac10" }//, "weapon_zm_pistol"}
static String:GiveAmmo[3][] = { "item_box_buckshot" , "item_ammo_357" , "item_ammo_smg1" }//, "item_ammo_pistol" }
//static String:Monsters[4][] = { "npc_zombie" , "npc_fastzombie" , "npc_poisonzombie" , "npc_dragzombie"}

#define WEAPONCOUNT 2
#define ZOMBIECOUNT 3


//Survivor options
#define SSIMPLYNOTHING 0
#define SGODMODE 1
#define SINVISIBLE 2
#define SLOWGRAV 3
#define SHUNDHEALTH 4
#define SFREEWEAPON 5
#define STIMEBOMB 6
#define SSELFSLAY 7
#define SONEHEALTH 8
#define SDEREGEN 9
#define STOTAL 9

//Zombie Master options
#define ZMNOTHING 10
#define ZMRESOURCES 11
#define ZMSTUCK 12
#define ZMTOTAL 2

//Allow, Min time, Max time, InfoA
new SOptSettings[STOTAL + ZMTOTAL + 2][4];
new ColorOffset, RenderModeOffset, ResourceOffset, SpeedOffset;//, OriginOffset;
new Float:fdefaultvalue[ZMMAXPLAYERS + 1];
new bool:AllowUse[2];

public Plugin:myinfo = 
{
	name = "ZM Roll the Dice",
	author = "Nican132",
	description = "Roll the dice",
	version = PLUGIN_VERSION,
	url = "http://www.sourcemod.net/"
};

public OnPluginStart()
{
	LoadTranslations("zmrtd.phrases")

	CreateConVar("sm_ZMRollTheDice_Version", PLUGIN_VERSION, "ZM RollTheDice Version", FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);
	
	RegConsoleCmd("say", Command_Say);
	RegConsoleCmd("say_team", Command_Say);
	
	RegAdminCmd("sm_roll", Command_ROLLME, ADMFLAG_CUSTOM4);
	
	CreateTimer(250.0, Propaganda , 1, TIMER_REPEAT);	
	
	maxents = GetMaxEntities();
	
	ColorOffset=FindSendPropOffs("CAI_BaseNPC","m_clrRender");
  	if(ColorOffset==-1)
		SetFailState("[RollTheDice:Commands] Error: Failed to find the Color offset, aborting");
    
	RenderModeOffset=FindSendPropOffs("CBaseAnimating","m_nRenderMode");
	if(RenderModeOffset==-1)
		SetFailState("[RollTheDice:Commands] Error: Failed to find the RenderMode offset, aborting");
		
	ResourceOffset=FindSendPropOffs("CBasePlayer","m_iZombiePool");
  	if(ResourceOffset==-1)
    	SetFailState("[RollTheDice:Commands] Error: Failed to find the Zombie Resources offset, aborting");
    	
	SpeedOffset=FindSendPropOffs("CBasePlayer","m_flLaggedMovementValue");
	if(SpeedOffset==-1)
    	SetFailState("[RollTheDice:Commands] Error: Failed to find the Speed offset, aborting");
    	
//	OriginOffset=FindSendPropOffs("CBaseEntity","m_vecOrigin");
//	if(OriginOffset==-1)
//		SetFailState("[HGR:Source] Error: Failed to find the Origin offset, aborting");
		
	HookEvent("player_spawn",PlayerSpawnEvent);
	HookEvent("round_end",RoundEndEvent);
}

public OnMapStart(){
	if(LoopTimer == INVALID_HANDLE){
		LoopTimer = CreateTimer(1.0, LoopThroughMinutes , 0, TIMER_REPEAT);
		//LogMessage("Map started - Loop created");
	}
	maxplayers = GetMaxClients();
	
	ActionsToVector();
	ResetEverything();
}

public OnMapEnd(){
	KillTimer(LoopTimer);
	LoopTimer = INVALID_HANDLE;
	//LogMessage("Loop killed");
}

public Action:LoopThroughMinutes(Handle:timer,any:index)
{
	//LogMessage("Loop called started");
	for(new i = 1; i <= maxplayers ; i ++){
		if(!IsClientInGame(i))
			continue;
		
		//LogMessage("Loop called - %d", i);	
		
		if(HasAlredyUsed[i] > 0)
			HasAlredyUsed[i]--;
		
		//PrintToChat(i, "%d -- %d", CurrentlyUsing[i], TimeLeft[i]);
		
		if(CurrentlyUsing[i] == 0)
			continue;
			
		TimeLeft[i]--;
		
		if(TimeLeft[i] == 0){
			FinishIt(i);
		}
	}
}

public OnClientDisconnect(index){
	FinishIt(index);
	HasAlredyUsed[index] = 0;
}

public FinishIt(index){
	switch(CurrentlyUsing[index]){
		case SGODMODE: RmGodMode(index);
		case SINVISIBLE: RmInvisibility(index);
		case SLOWGRAV: RmLowGrav(index);
		case STIMEBOMB: RmTimeBomb(index);
		case ZMSTUCK: RmZmStuck(index);
	}
	CurrentlyUsing[index] = 0;
	TimeLeft[index] = 0;
}

public Action:Propaganda(Handle:timer,any:index)
{
	PrintToChatAll("%t","GlobalMessageA")
	PrintToChatAll("%t","GlobalMessageB")
}

public RollDice(index, opt){
	new usrteam = GetClientTeam(index);
	if(usrteam == 2){
		switch(opt){
			case SSIMPLYNOTHING: StSimplyNothing(index);
			case SGODMODE: StGodMode(index);
			case SINVISIBLE: StInvisibility(index);
			case SLOWGRAV: StLowGrav(index);
			case SHUNDHEALTH: StPlusHealth(index);
			case SFREEWEAPON: StFreeWeapon(index);
			case STIMEBOMB: StTimeBomb(index);
			case SSELFSLAY: StSelfSlay(index);
			case SONEHEALTH: StOneHealth(index);
			case SDEREGEN: StDeregen(index);
		}
	} else if ( usrteam == 3){
		opt += STOTAL + 1;
		switch(opt){
			case ZMNOTHING: StSimplyNothing(index);
			case ZMRESOURCES: ZMFree(index);
			case ZMSTUCK: StZmStuck(index);
		}	
	}
}

public Action:Command_Say(index,argc)
{
	decl String:args[192],String:command[192];
	new i
	GetCmdArgString(args,192);
	GetLiteralString(args,command,192);
	
	for(new x=0 ; x<MAXTRIGGERS ; x++){
    	if( StrEqual(command,triggers[x]) ){
			if(index == 0){
				PrintToServer("[NC] %t","OnlyPlayers");
				return Plugin_Handled;
			}
			if(!IsPlayerAlive(index)){
				PrintToChat(index,"[NC] %t","YouDead");
				return Plugin_Handled;
			}
			if(HasAlredyUsed[index] > 0){
				PrintToChat(index,"[NC] %t","WaitForIT",HasAlredyUsed[index]);
				return Plugin_Handled;
			}	
    		
			new usrteam = GetClientTeam(index);
			if(usrteam >= 2){
				if(usrteam == 2 && !AllowUse[0]){
					PrintToChat(index,"[NC] %t", "Survivorscant");
					return Plugin_Handled;
				} else if(usrteam == 3 && !AllowUse[1]){
					PrintToChat(index,"[NC] %t","ZMcant");
					return Plugin_Handled;
				}
				
				HasAlredyUsed[index] = TIMETILLNEXT;				
				
				i = GetRandomInt(0 , usrteam == 2 ? STOTAL :  ZMTOTAL);
				while(SOptSettings[i][0] == 0)
					i = GetRandomInt(0 , usrteam == 2 ? STOTAL :  ZMTOTAL);
				
				RollDice(index, i);		
								
				return Plugin_Continue;
			}else{
      			PrintToChat(index,"[NC] %t","OnlyAlive");  
      			return Plugin_Handled;
			}
		}
	}
	return Plugin_Continue;
}

public Action:Command_ROLLME(index, args){
	if(index == 0){
		PrintToConsole(index, "[NC] %t" , "OnlyPlayers");
		return Plugin_Handled;
	}
	if(!IsPlayerAlive(index)){
		PrintToConsole(index,"[NC] %t","YouDead");
		return Plugin_Handled;
	}
	if (args < 1){
		ReplyToCommand(index, "[SM] Usage: sm_roll <#id>");
		return Plugin_Handled;	
	}
	if(CurrentlyUsing[index] > 0){
		ReplyToCommand(index, "[SM] %t", "YouAlredyUnder");
		return Plugin_Handled;
	}	
	
	new String:Target[64]
	GetCmdArg(1, Target, sizeof(Target));
	
	RollDice(index, StringToInt(Target));
	
	return Plugin_Handled;
}

//Nothing
public StSimplyNothing(index){
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	PrintToChatAll("[NC] %t","NothingHappens",name);
}

//Godmode
public StGodMode(index){
	new randomnum = GetRandomInt( SOptSettings[SGODMODE][1] , SOptSettings[SGODMODE][2] );
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	TimeLeft[index] = randomnum;
	CurrentlyUsing[index] = SGODMODE;
	
	SetEntProp(index,Prop_Data,"m_takedamage",0,1); // Give godmode
	
	PrintToChatAll("[NC] %t","GodModeWin", name, randomnum);
}

public RmGodMode(index){
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	SetEntProp(index,Prop_Data,"m_takedamage",2,1); // Take godmode	
	PrintToChatAll("[NC] %t", "NoGodMode" ,name);
}

//Invisibility
public StInvisibility(index){
	new randomnum = GetRandomInt( SOptSettings[SINVISIBLE][1] , SOptSettings[SINVISIBLE][2] );
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	TimeLeft[index] = randomnum;
	CurrentlyUsing[index] = SINVISIBLE;    
    
	SetEntData(index, ColorOffset+3, SOptSettings[SINVISIBLE][3], 1, true);
	SetEntData(index, RenderModeOffset, 3, 1, true);
	
	PrintToChatAll("[NC] %t", "InvisibilityWin", name, randomnum);
}

public RmInvisibility(index){
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	SetEntData(index, ColorOffset+3, 255, 1, true);
	SetEntData(index, RenderModeOffset, 3, 1, true);
	
	PrintToChatAll("[NC] %t", "NoInvisibility" , name);
}

//LowGravity
public StLowGrav(index){
	new randomnum = GetRandomInt( SOptSettings[SLOWGRAV][1] , SOptSettings[SLOWGRAV][2] );
	new Float:gravity;
	
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	TimeLeft[index] = randomnum;
	CurrentlyUsing[index] = SLOWGRAV;
	fdefaultvalue[index] = GetEntPropFloat(index, Prop_Data,"m_flGravity");
	//gravity = GetEntPropFloat(index, Prop_Data,"m_flGravity");
	//PrintToChat(index,"[NC] Gravity: %f", gravity);
	
	gravity = float(SOptSettings[SLOWGRAV][3]) / 100.0;

	SetEntPropFloat(index,Prop_Data,"m_flGravity",gravity);
	
	PrintToChatAll("[NC] %t", "LowGravWin" , name, randomnum);
}

public RmLowGrav(index){
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	SetEntPropFloat(index,Prop_Data,"m_flGravity", fdefaultvalue[index]);
	
	PrintToChatAll("[NC] %t", "NoLowGrav" ,name);
}

//Extra health
public StPlusHealth(index){
	new randomnum = GetRandomInt( SOptSettings[SHUNDHEALTH][1] , SOptSettings[SHUNDHEALTH][2] );
	new newhealth = GetClientHealth(index) + randomnum;
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	SetEntProp(index , Prop_Send, "m_iHealth", newhealth, 1);
	
	PrintToChatAll("[NC] %t", "ExtraHealth" ,name, randomnum);
}

//Give weapon
public StFreeWeapon(index){	
	new weap = GetUserWeapon(index);
	
	if(weap == -1){
		weap = SOptSettings[SFREEWEAPON][3];
		GivePlayerItem(index, GiveWeapon[ weap ]);
	}
	
	GivePlayerItem(index,GiveAmmo[weap]); 
	GivePlayerItem(index,GiveAmmo[weap]);
	
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	PrintToChatAll("[NC] %t", "FreeWeapon" , name);
}

//TimeBomb
public StTimeBomb(index){
	new randomnum = GetRandomInt( SOptSettings[STIMEBOMB][1] , SOptSettings[STIMEBOMB][2] );
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	TimeLeft[index] = randomnum;
	CurrentlyUsing[index] = STIMEBOMB;
	
	PrintToChatAll("[NC] %t", "GoingToDie",name, randomnum);	
}

public RmTimeBomb(index){
    if(GetClientTeam(index) == 2){
    	decl String:name[65];
    	
    	SlayPlayer(index);
    	GetClientName(index, name, sizeof(name));
    	
    	PrintToChatAll("[NC] %t", "YouNowDead" ,name);	
	}
}

//Self Slay
public StSelfSlay(index){
	SlayPlayer(index);
	
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	PrintToChatAll("[NC] %t", "YouNowDead" ,name);
}

//One health
public StOneHealth(index){	
	SetEntProp(index, Prop_Send, "m_iHealth",  SOptSettings[SONEHEALTH][3], 1);
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	PrintToChatAll("[NC] %t", "LowLife" , name, SOptSettings[SONEHEALTH][3]);
}

//Deregenaration
public StDeregen(index){
	new randomnum = GetRandomInt( SOptSettings[SDEREGEN][1] , SOptSettings[SDEREGEN][2] );
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	IgniteEntity(index, float(randomnum)) 
	
	PrintToChatAll("[NC] %t","BurningDown" ,name );
}

//Free resources
public ZMFree(index){
	new randomnum = GetRandomInt( 25, 200 );
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	SetZMResources(index, randomnum, true);
	
	PrintToChatAll("[NC] %t", "FreeResources" ,name, randomnum);
}

//Unstuck ZM
public StZmStuck(index){
	new randomnum = GetRandomInt( 5, 15 );
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	fdefaultvalue[index] = GetEntDataFloat(index,SpeedOffset);	
	TimeLeft[index] = randomnum;
	CurrentlyUsing[index] = ZMSTUCK;
	
	SetEntDataFloat(index,SpeedOffset,0.0,true);
	
	PrintToChatAll("[NC] %t", "StuckFor" ,name, randomnum);
}

public RmZmStuck(index){
	decl String:name[65];
	GetClientName(index, name, sizeof(name));
	
	SetEntDataFloat(index,SpeedOffset, fdefaultvalue[index],true);
	
	PrintToChatAll("[NC] %t", "Freedom", name);
}



stock GetLiteralString(const String:cmd[],String:buffer[],maxlength)
{
  strcopy(buffer,strlen(cmd)+1,cmd);
  ReplaceString(buffer,maxlength,"\"","");
  TrimString(buffer);
}

public ActionsToVector()
{
	new String:file[256], String:mapname[32];
	
	GetCurrentMap(mapname, sizeof(mapname));
	
	BuildPath(Path_SM, file, sizeof(file),"configs/zmdice/%s.txt",mapname);
	if(!FileExists(file))
		BuildPath(Path_SM, file, sizeof(file),"configs/zmdice/default.txt");
 
	if(!FileExists(file)){
		SetFailState("Could not find reading file");
	}
	
	new Handle:kv = CreateKeyValues("ZMdice")
	FileToKeyValues(kv, file);
	
	if (!KvGotoFirstSubKey(kv))
	{
		SetFailState("No entries");
	}
  
	decl String:buffer[255], thiskey, i
	do
	{
		KvGetSectionName(kv, buffer, sizeof(buffer));
		
		thiskey = StringToInt(buffer);
		
		SOptSettings[ thiskey ][0] = KvGetNum(kv, "allow" , 0);
		SOptSettings[ thiskey ][1] = KvGetNum(kv, "mintime" , 0);
		SOptSettings[ thiskey ][2] = KvGetNum(kv, "maxtime" , 0);
		SOptSettings[ thiskey ][3] = KvGetNum(kv, "extra" , 0);
	
	} while (KvGotoNextKey(kv))
 
	CloseHandle(kv);
    
	if(SOptSettings[SINVISIBLE][3] < 0 ) SOptSettings[SINVISIBLE][3] = 0;
	if(SOptSettings[SINVISIBLE][3] > 255) SOptSettings[SINVISIBLE][3]=255;
	if(SOptSettings[SFREEWEAPON][3] == 0 || SOptSettings[SFREEWEAPON][3] > WEAPONCOUNT ) SOptSettings[SFREEWEAPON][0] = 0;

	for(i = 0; i <= STOTAL; i++){
		if(SOptSettings[i][0] == 1){
			AllowUse[0] = true;
			break;
		}
	}
  
	for(i = ZMNOTHING; i <= ZMNOTHING + ZMTOTAL; i++){
		if(SOptSettings[i][0] == 1){
			AllowUse[1] = true;
			break;
    	}
  	}
}

public SlayPlayer(index){
	ForcePlayerSuicide(index);
}

stock SetZMResources(client, amount, bool:add = false){
	if(add) amount +=  GetZMZMResources(client);
	SetEntData(client, ResourceOffset, amount, 4, true);
}

public GetZMZMResources(client){
	return GetEntData(client, ResourceOffset, 4);
}


/*
public Float:GetEntityOrigin(entity)
{
  new Float:output;
  GetEntDataVector(entity,OriginOffset,output);
  return output
} */

stock GetUserWeapon(client, rtnid = false){
	decl String:name[64];
	new a;
	for(new i=0;i<= maxents ;i++){
		if(!IsValidEntity(i))
			continue;
			
		if(GetEntData(i, 1128, 1) != client)	
				continue;

		if(GetEdictClassname(i, name, sizeof(name))){
			for(a=0; a<= WEAPONCOUNT; a++){
				if(StrEqual(name, GiveWeapon[a]))
					return rtnid ? i : a;
			}			
		}
	}
	return -1;
}


public RoundEndEvent(Handle:event,const String:name[],bool:dontBroadcast){
	ResetEverything();
}

ResetEverything(){
	for(new i = 1; i<= maxplayers ; i++){
		HasAlredyUsed[i] = 0;
  		FinishIt(i);
	}
}

public PlayerSpawnEvent(Handle:event,const String:name[],bool:dontBroadcast){
	new index=GetClientOfUserId(GetEventInt(event,"userid")); // Get clients index
	HasAlredyUsed[index] = 0;
	FinishIt(index);
}
